选择

条件测试的常见实现

############### test ########################
man test 
test -f /tmp/tmp.txt && echo "文件存在"
test -f /tmp/tmp.txt || echo "文件不存在"
test -f /tmp/tmp.txt && echo "文件存在" || echo "文件不存在"
test -z "hello" && echo "字符串为空" || echo "字符串不为空"

############### [] ##############################
[ -f /tmp/tmp.txt ] && echo "文件存在" || echo "文件不存在"


############### [[]] ##############################
[[ -f /tmp/tmp.txt ]] && echo "文件存在" || echo "文件不存在"

条件语句 if

if list; then list; [ elif list; then list; ] ... [ else list; ] fi

if [ -f /tmp/tmp.txt ]; then
    echo "文件存在"
fi

if [ -f /tmp/tmp.txt ]; then
    echo "文件存在"
else
    echo "文件不存在"
fi

if [ -f /tmp/tmp1.txt ]; then
    echo "tmp1文件存在"
eleif [ -f /tmp/tmp2.txt ]; then
    echo "tmp2文件存在"
eleif [ -f /tmp/tmp2.txt ]; then
    echo "tmp2文件存在"    
else
    echo "tmp1 tmp2 tmp 文件都不存在"
fi

if cat /tmp/tmp.txt | grep hello; then
    echo "包含hello"
fi


if [ -f /tmp/tmp.txt ]; then echo "文件存在"; fi
if [ -f /tmp/tmp.txt ]; then echo "文件存在"; else echo "文件不存在"; fi

man-test

字符串比较,整数比较

TEST(1)                                                                                     User Commands                                                                                    TEST(1)



NAME
       test - check file types and compare values

SYNOPSIS
       test EXPRESSION
       test

       [ EXPRESSION ]
       [ ]
       [ OPTION

DESCRIPTION
       Exit with the status determined by EXPRESSION.

       --help display this help and exit

       --version
              output version information and exit

       An omitted EXPRESSION defaults to false.  Otherwise, EXPRESSION is true or false and sets exit status.  It is one of:

       ( EXPRESSION )
              EXPRESSION is true

       ! EXPRESSION
              EXPRESSION is false

       EXPRESSION1 -a EXPRESSION2
              both EXPRESSION1 and EXPRESSION2 are true

       EXPRESSION1 -o EXPRESSION2
              either EXPRESSION1 or EXPRESSION2 is true

       -n STRING
              the length of STRING is nonzero

       STRING equivalent to -n STRING

       -z STRING
              the length of STRING is zero

       STRING1 = STRING2
              the strings are equal

       STRING1 != STRING2
              the strings are not equal

       INTEGER1 -eq INTEGER2
              INTEGER1 is equal to INTEGER2

       INTEGER1 -ge INTEGER2
              INTEGER1 is greater than or equal to INTEGER2

       INTEGER1 -gt INTEGER2
              INTEGER1 is greater than INTEGER2

       INTEGER1 -le INTEGER2
              INTEGER1 is less than or equal to INTEGER2

       INTEGER1 -lt INTEGER2
              INTEGER1 is less than INTEGER2

       INTEGER1 -ne INTEGER2
              INTEGER1 is not equal to INTEGER2

       FILE1 -ef FILE2
              FILE1 and FILE2 have the same device and inode numbers

       FILE1 -nt FILE2
              FILE1 is newer (modification date) than FILE2

       FILE1 -ot FILE2
              FILE1 is older than FILE2

       -b FILE
              FILE exists and is block special

       -c FILE
              FILE exists and is character special

       -d FILE
              FILE exists and is a directory

       -e FILE
              FILE exists

       -f FILE
              FILE exists and is a regular file

       -g FILE
              FILE exists and is set-group-ID

       -G FILE
              FILE exists and is owned by the effective group ID

       -h FILE
              FILE exists and is a symbolic link (same as -L)

       -k FILE
              FILE exists and has its sticky bit set

       -L FILE
              FILE exists and is a symbolic link (same as -h)

       -O FILE
              FILE exists and is owned by the effective user ID

       -p FILE
              FILE exists and is a named pipe

       -r FILE
              FILE exists and read permission is granted

       -s FILE
              FILE exists and has a size greater than zero

       -S FILE
              FILE exists and is a socket

       -t FD  file descriptor FD is opened on a terminal

       -u FILE
              FILE exists and its set-user-ID bit is set

       -w FILE
              FILE exists and write permission is granted

       -x FILE
              FILE exists and execute (or search) permission is granted

       Except for -h and -L, all FILE-related tests dereference symbolic links.  Beware that parentheses need to be escaped (e.g., by backslashes) for shells.  INTEGER may also be -l STRING, which
       evaluates to the length of STRING.

       NOTE: [ honors the --help and --version options, but test does not.  test treats each of those as it treats any other nonempty STRING.

       NOTE: your shell may have its own version of test and/or [, which usually supersedes the version described here.  Please refer to your shell's documentation for details about the options it
       supports.

       GNU coreutils online help: <http://www.gnu.org/software/coreutils/> Report test translation bugs to <http://translationproject.org/team/>

AUTHOR
       Written by Kevin Braunsdorf and Matthew Bradburn.

COPYRIGHT
       Copyright © 2013 Free Software Foundation, Inc.  License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
       This is free software: you are free to change and redistribute it.  There is NO WARRANTY, to the extent permitted by law.

SEE ALSO
       The full documentation for test is maintained as a Texinfo manual.  If the info and test programs are properly installed at your site, the command

              info coreutils 'test invocation'

       should give you access to the complete manual.



GNU coreutils 8.22                                                                          October 2018                                                                                     TEST(1)

case条件语句

case "$1" in
start)
    echo "start"
    ;;
stop)
    echo "stop"
    ;;
status)
    echo $"Configured devices:"
    echo lo $interfaces
    echo $"Currently active devices:"
    echo $(/sbin/ip -o link show up | awk -F ": " '{ print $2 }')
    ;;
restart|reload|force-reload)
    cd "$CWD"
    $0 stop
    $0 start
    rc=$?
    ;;
*)
    echo $"Usage: $0 {start|stop|status|restart|reload|force-reload}"
    exit 2
esac


可查看系统自带的网卡脚本观察case使用规则